/* $Id: mgavb.h,v 1.1 1999/07/31 07:07:55 crow Exp $ */
/*
 * GLX Hardware Device Driver for Matrox Millenium G200
 * Copyright (C) 1999 Wittawat Yamwong
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * WITTAWAT YAMWONG, OR ANY OTHER CONTRIBUTORS BE LIABLE FOR ANY CLAIM, 
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR 
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE 
 * OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *
 *    Wittawat Yamwong <Wittawat.Yamwong@stud.uni-hannover.de>
 */

#ifndef MGAVB_INC
#define MGAVB_INC

#include "mesaglx/vb.h"

#define MGA_VB_SIZE VB_SIZE

typedef struct mga_vertex_t mgaVertex;
typedef struct mga_vertex_t *mgaVertexPtr;
		 
struct mga_vertex_t {
  int idx;	   /* Mesa's vertex number */
  int	ceilY;	/* CEIL(vert->y) */
  GLfloat x,y,z;   /* x,y are offset by (-0.5,-0.5) */
  GLfloat s,t,v;   /* scaled by 2^[STQ]BIT */
  GLfloat fog;     /* scaled by 2^15 */
  GLfloat r,g,b,a;  /* scaled by 2^15 */
  GLfloat sr,sg,sb; /* scaled by 2^15 */
};

#ifdef MESA31
typedef void (*mgaRasterSetupFunc)(struct vertex_buffer *,GLuint,GLuint);
#else
typedef void (*mgaRasterSetupFunc)(GLcontext*,GLuint,GLuint);
#endif

mgaRasterSetupFunc mgaChooseRasterSetupFunc(GLcontext *ctx);

#ifdef MESA31
#  define VBCOLOR ColorPtr->data
#  define VBWIN Win.data
#else
#  define VBCOLOR Color 
#  define VBWIN Win
#endif

#endif
