/*
 * GLX Hardware Device Driver for Matrox G200/G400
 * warp engine interface
 * Copyright (c) 1999 Ralph Giles
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * MATROX GRAPHICS INC., OR ANY OTHER CONTRIBUTORS BE LIABLE FOR ANY CLAIM, 
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR 
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE 
 * OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 * 
 * original by Ralph Giles <giles@ashlu.bc.ca> 1999 July 27
 * 
 */

#include "mgacommon.h"
#include "warp.h"	/* matrox microcode */
#include "mgawarp.h"

/* The warp microcode routines are defined separately in warp.h
 * these get loaded into the setup engine(s) to do the triangle
 * transforms. the extension specifies the enabled path:
 *
 *  t is for single-stage textured
 *  t2 is for two-stage textured (G400 only)
 *  g is for Gouraud color interpolation (always on)
 *  z for Z buffer interpolated
 *  s is for specular hilight
 *  a is for alpha blended (?)
 *  f is for fogged
 *
 *  fill in null values in the vertex structure for features you're
 *  not using.
 */

/* load microcode
   this function attempts to load the microcode defined in warp.h
   into the warp instruction cache(s) hopefully after this we have
   a working setup pipe	
 */
int	mgaLoadWarpCode(/* specify desired pipe here */)
{
}
